<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for sendDataExtraccionRequest StructType
 * Meta information extracted from the WSDL
 * - documentation: Envio datos de extracción de aguas
 * @subpackage Structs
 */
class SendDataExtraccionRequest extends AbstractStructBase
{
    /**
     * The dataExtraccionSuperficial
     * Meta information extracted from the WSDL
     * - choice: dataExtraccionSuperficial | dataExtraccionSubterranea
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * - minOccurs: 0
     * @var \StructType\SendDataExtraccionSuperficial
     */
    public $dataExtraccionSuperficial;
    /**
     * The dataExtraccionSubterranea
     * Meta information extracted from the WSDL
     * - choice: dataExtraccionSuperficial | dataExtraccionSubterranea
     * - choiceMaxOccurs: 1
     * - choiceMinOccurs: 1
     * - minOccurs: 0
     * @var \StructType\SendDataExtraccionSubterranea
     */
    public $dataExtraccionSubterranea;
    /**
     * Constructor method for sendDataExtraccionRequest
     * @uses SendDataExtraccionRequest::setDataExtraccionSuperficial()
     * @uses SendDataExtraccionRequest::setDataExtraccionSubterranea()
     * @param \StructType\SendDataExtraccionSuperficial $dataExtraccionSuperficial
     * @param \StructType\SendDataExtraccionSubterranea $dataExtraccionSubterranea
     */
    public function __construct(\StructType\SendDataExtraccionSuperficial $dataExtraccionSuperficial = null, \StructType\SendDataExtraccionSubterranea $dataExtraccionSubterranea = null)
    {
        $this
            ->setDataExtraccionSuperficial($dataExtraccionSuperficial)
            ->setDataExtraccionSubterranea($dataExtraccionSubterranea);
    }
    /**
     * Get dataExtraccionSuperficial value
     * @return \StructType\SendDataExtraccionSuperficial|null
     */
    public function getDataExtraccionSuperficial()
    {
        return isset($this->dataExtraccionSuperficial) ? $this->dataExtraccionSuperficial : null;
    }
    /**
     * This method is responsible for validating the value passed to the setDataExtraccionSuperficial method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDataExtraccionSuperficial method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateDataExtraccionSuperficialForChoiceConstraintsFromSetDataExtraccionSuperficial($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'dataExtraccionSubterranea',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property dataExtraccionSuperficial can\'t be set as the property %s is already set. Only one property must be set among these properties: dataExtraccionSuperficial, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set dataExtraccionSuperficial value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SendDataExtraccionSuperficial $dataExtraccionSuperficial
     * @return \StructType\SendDataExtraccionRequest
     */
    public function setDataExtraccionSuperficial(\StructType\SendDataExtraccionSuperficial $dataExtraccionSuperficial = null)
    {
        // validation for constraint: choice(dataExtraccionSuperficial, dataExtraccionSubterranea)
        if ('' !== ($dataExtraccionSuperficialChoiceErrorMessage = self::validateDataExtraccionSuperficialForChoiceConstraintsFromSetDataExtraccionSuperficial($dataExtraccionSuperficial))) {
            throw new \InvalidArgumentException($dataExtraccionSuperficialChoiceErrorMessage, __LINE__);
        }
        if (is_null($dataExtraccionSuperficial) || (is_array($dataExtraccionSuperficial) && empty($dataExtraccionSuperficial))) {
            unset($this->dataExtraccionSuperficial);
        } else {
            $this->dataExtraccionSuperficial = $dataExtraccionSuperficial;
        }
        return $this;
    }
    /**
     * Get dataExtraccionSubterranea value
     * @return \StructType\SendDataExtraccionSubterranea|null
     */
    public function getDataExtraccionSubterranea()
    {
        return isset($this->dataExtraccionSubterranea) ? $this->dataExtraccionSubterranea : null;
    }
    /**
     * This method is responsible for validating the value passed to the setDataExtraccionSubterranea method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDataExtraccionSubterranea method
     * This has to validate that the property which is being set is the only one among the given choices
     * @param mixed $value
     * @return string A non-empty message if the values does not match the validation rules
     */
    public function validateDataExtraccionSubterraneaForChoiceConstraintsFromSetDataExtraccionSubterranea($value)
    {
        $message = '';
        if (is_null($value)) {
            return $message;
        }
        $properties = [
            'dataExtraccionSuperficial',
        ];
        try {
            foreach ($properties as $property) {
                if (isset($this->{$property})) {
                    throw new \InvalidArgumentException(sprintf('The property dataExtraccionSubterranea can\'t be set as the property %s is already set. Only one property must be set among these properties: dataExtraccionSubterranea, %s.', $property, implode(', ', $properties)), __LINE__);
                }
            }
        } catch (\InvalidArgumentException $e) {
            $message = $e->getMessage();
        }
        return $message;
    }
    /**
     * Set dataExtraccionSubterranea value
     * This property belongs to a choice that allows only one property to exist. It is
     * therefore removable from the request, consequently if the value assigned to this
     * property is null, the property is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SendDataExtraccionSubterranea $dataExtraccionSubterranea
     * @return \StructType\SendDataExtraccionRequest
     */
    public function setDataExtraccionSubterranea(\StructType\SendDataExtraccionSubterranea $dataExtraccionSubterranea = null)
    {
        // validation for constraint: choice(dataExtraccionSuperficial, dataExtraccionSubterranea)
        if ('' !== ($dataExtraccionSubterraneaChoiceErrorMessage = self::validateDataExtraccionSubterraneaForChoiceConstraintsFromSetDataExtraccionSubterranea($dataExtraccionSubterranea))) {
            throw new \InvalidArgumentException($dataExtraccionSubterraneaChoiceErrorMessage, __LINE__);
        }
        if (is_null($dataExtraccionSubterranea) || (is_array($dataExtraccionSubterranea) && empty($dataExtraccionSubterranea))) {
            unset($this->dataExtraccionSubterranea);
        } else {
            $this->dataExtraccionSubterranea = $dataExtraccionSubterranea;
        }
        return $this;
    }
}
